> ## Documentation Index
> Fetch the complete documentation index at: https://docs.alvys.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Record customer payment

> Record a customer payment against one or more customer invoices in Alvys, including check or ACH reference, amount, deposit date, and payment terms.

This endpoint allows external systems to post customer payments into Alvys and apply them to the corresponding load.

### Path Parameters

| Parameter | Type   | Required | Description               |
| --------- | ------ | -------- | ------------------------- |
| version   | string | Yes      | API version (e.g., `1.0`) |

### Request Body

Content-Type: `application/json-patch+json`

| Field           | Type               | Required | Description                                                    |
| --------------- | ------------------ | -------- | -------------------------------------------------------------- |
| LoadNumber      | string             | Yes      | Load number the payment should be applied to                   |
| Amount          | object             | Yes      | Payment amount object                                          |
| Amount.Amount   | number             | Yes      | Payment amount value                                           |
| Amount.Currency | integer            | Yes      | Currency identifier                                            |
| CheckNumber     | string             | No       | Check number if the payment method uses a check                |
| InvoiceNumber   | string             | No       | Invoice number associated with the payment                     |
| Note            | string             | No       | Additional note related to the payment                         |
| PaymentDate     | string (date-time) | Yes      | Date when the payment was made                                 |
| PaymentMethod   | string             | No       | Payment method used (for example Check, ACH, Wire)             |
| ReferenceNumber | string             | Yes      | External reference number for idempotency and payment tracking |

### Example Request

```json theme={null}
{
  "LoadNumber": "string",
  "Amount": {
    "Amount": 0,
    "Currency": 0
  },
  "PaymentDate": "2026-03-16T13:57:56.427Z",
  "ReferenceNumber": "string",
  "InvoiceNumber": "string",
  "PaymentMethod": "string",
  "CheckNumber": "string",
  "Note": "string"
}
```

### Response Body

| Field                  | Type    | Description                                    |
| ---------------------- | ------- | ---------------------------------------------- |
| Id                     | string  | Unique identifier of the recorded payment      |
| LoadNumber             | string  | Load number the payment was applied to         |
| Status                 | string  | Current load status after applying the payment |
| TotalPaid              | object  | Total amount paid by the customer to date      |
| TotalPaid.Amount       | number  | Monetary amount                                |
| TotalPaid.Currency     | integer | Currency identifier                            |
| TotalBillable          | object  | Total billable amount for the load             |
| TotalBillable.Amount   | number  | Monetary amount                                |
| TotalBillable.Currency | integer | Currency identifier                            |

### Notes

* This endpoint records **customer payments against loads**.
* The request body content type exposed by the API is `application/json-patch+json`.
* `ReferenceNumber` is required and is used for **idempotency**. Repeating the same `ReferenceNumber` for the same load returns the original payment instead of creating a duplicate.
* This endpoint accepts payments only when the load is in one of these statuses:

  * `Invoiced`
  * `Completed`
  * `Financed`
* Loads in non-payable statuses such as `Dispatched` are rejected with:

```text theme={null}
400 Bad Request
Load must be in one of: Invoiced, Completed, Financed.
```

* If the `LoadNumber` does not exist, the endpoint returns:

```text theme={null}
404 Not Found
```

* If `Amount.Amount` is negative or zero, the endpoint returns:

```text theme={null}
400 Bad Request
Amount must be greater than zero.
```

* If `ReferenceNumber` is empty or omitted, the endpoint returns:

```text theme={null}
400 Bad Request
The ReferenceNumber field is required.
```


## OpenAPI

````yaml POST /api/p/v{version}/invoices/customer-payments
openapi: 3.0.1
info:
  title: Alvys
  description: >-
    Alvys provides a robust set of REST APIs to allow you to integrate Alvys
    into virtually any platform. These APIs cover most of Alvys' major product
    areas with additional endpoints being added regularly based on customer
    requests.
  contact:
    name: Alvys Support
    url: https://www.alvys.com/resources/contact/
  version: v1
servers:
  - url: https://integrations.alvys.com
    description: Public API Server
  - url: https://api.alvys.com/
    description: Public API Server
security:
  - Public: []
tags:
  - name: Authentication
    description: Obtain an OAuth 2.0 access token for the Alvys Public API.
  - name: Carrier Settlement Statements
    description: >-
      Search carrier settlement statements and retrieve a single statement by
      number.
  - name: Carriers
    description: Read carrier records, search carriers, and manage carrier documents.
  - name: Customers
    description: Create, read, update, delete, and search customer records.
  - name: Deductions
    description: >-
      Create one-time deductions and search or delete existing deduction
      records.
  - name: DispatchPreferences
    description: Dispatch preferences endpoints for reading dispatch rules and preferences.
  - name: Driver Settlement Statements
    description: >-
      Search driver settlement statements and retrieve a single statement by
      number.
  - name: Drivers
    description: >-
      Read driver records, search drivers and driver events, and manage driver
      documents.
  - name: Fuel
    description: Read and search fuel transactions.
  - name: Invoices
    description: >-
      Read invoices, create carrier invoices, and record carrier and customer
      payments.
  - name: Loads
    description: Read, update, search loads, and manage load documents and notes.
  - name: Locations
    description: Read and search company location details.
  - name: Maintenance
    description: Read and search maintenance records.
  - name: Tenders
    description: Create, accept, reject, cancel, update, and search inbound EDI tenders.
  - name: Tolls
    description: Read and search toll transactions.
  - name: Trailers
    description: Read trailers, search trailer events, and manage trailer documents.
  - name: Trips
    description: >-
      Read, search trips, manage trip documents, and record stop appointments,
      arrivals, and departures.
  - name: Trucks
    description: Read trucks, search truck events, and manage truck documents.
  - name: Users
    description: List and search users.
  - name: Visibility
    description: >-
      Read inbound and outbound visibility history and search outbound
      visibility errors.
  - name: Webhooks
    description: >-
      Create, read, update, delete, enable, disable, verify, test, and rotate
      secrets for webhook subscriptions; read event types, delivery logs, and
      health metrics.
paths:
  /api/p/v{version}/invoices/customer-payments:
    post:
      tags:
        - Invoices
      summary: Record customer payment
      parameters:
        - name: version
          in: path
          description: API version (e.g., 1.0)
          required: true
          schema:
            type: string
            default: '1.0'
            example: '1.0'
      requestBody:
        content:
          application/json-patch+json:
            schema:
              allOf:
                - $ref: >-
                    #/components/schemas/Alvys.Models.Invoices.Request.CustomerPaymentRequest
          application/json:
            schema:
              allOf:
                - $ref: >-
                    #/components/schemas/Alvys.Models.Invoices.Request.CustomerPaymentRequest
          text/json:
            schema:
              allOf:
                - $ref: >-
                    #/components/schemas/Alvys.Models.Invoices.Request.CustomerPaymentRequest
          application/*+json:
            schema:
              allOf:
                - $ref: >-
                    #/components/schemas/Alvys.Models.Invoices.Request.CustomerPaymentRequest
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Alvys.Models.Invoices.Response.CustomerPaymentResponse
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Microsoft.AspNetCore.Mvc.ValidationProblemDetails
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
        '429':
          description: Too Many Requests
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/Microsoft.AspNetCore.Mvc.ProblemDetails'
      security:
        - Public: []
components:
  schemas:
    Alvys.Models.Invoices.Request.CustomerPaymentRequest:
      required:
        - Amount
        - LoadNumber
        - PaymentDate
        - ReferenceNumber
      type: object
      properties:
        LoadNumber:
          type: string
        Amount:
          allOf:
            - $ref: '#/components/schemas/Alvys.Money'
        PaymentDate:
          type: string
          format: date-time
        ReferenceNumber:
          type: string
        InvoiceNumber:
          type: string
          nullable: true
        PaymentMethod:
          type: string
          nullable: true
        CheckNumber:
          type: string
          nullable: true
        Note:
          type: string
          nullable: true
      additionalProperties: false
    Alvys.Models.Invoices.Response.CustomerPaymentResponse:
      required:
        - Id
        - LoadNumber
        - Status
        - TotalBillable
        - TotalPaid
      type: object
      properties:
        Id:
          type: string
        LoadNumber:
          type: string
        Status:
          type: string
        TotalPaid:
          allOf:
            - $ref: '#/components/schemas/Alvys.Money'
        TotalBillable:
          allOf:
            - $ref: '#/components/schemas/Alvys.Money'
      additionalProperties: false
    Microsoft.AspNetCore.Mvc.ValidationProblemDetails:
      required:
        - Errors
      type: object
      properties:
        Errors:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
        Type:
          type: string
          nullable: true
        Title:
          type: string
          nullable: true
        Status:
          type: integer
          format: int32
          nullable: true
        Detail:
          type: string
          nullable: true
        Instance:
          type: string
          nullable: true
      additionalProperties: {}
    Microsoft.AspNetCore.Mvc.ProblemDetails:
      type: object
      properties:
        Type:
          type: string
          nullable: true
        Title:
          type: string
          nullable: true
        Status:
          type: integer
          format: int32
          nullable: true
        Detail:
          type: string
          nullable: true
        Instance:
          type: string
          nullable: true
      additionalProperties: {}
    Alvys.Money:
      required:
        - Amount
      type: object
      properties:
        Amount:
          type: number
          format: double
        Currency:
          type: integer
          format: int32
          nullable: true
      additionalProperties: false
  securitySchemes:
    Public:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        OAuth 2.0 client-credentials access token. Obtain one from
        https://auth.alvys.com/oauth/token (grant_type=client_credentials,
        audience=https://api.alvys.com/public/), then paste it here. The
        playground sends it as `Authorization: Bearer <token>`.

````